package database;

/**
 * A_column_table association proxy interface.
 */
public interface AColumnTable extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param column Value of the first association end.
     * @param table Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(database.Column column, database.Table table);
    /**
     * Queries the instance objects that are related to a particular instance 
     * object by a link in the current associations link set.
     * @param table Required value of the second association end.
     * @return Collection of related objects.
     */
    public java.util.Collection getColumn(database.Table table);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param column Required value of the first association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.Table getTable(database.Column column);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param column Value of the first association end.
     * @param table Value of the second association end.
     */
    public boolean add(database.Column column, database.Table table);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param column Value of the first association end.
     * @param table Value of the second association end.
     */
    public boolean remove(database.Column column, database.Table table);
}
