package database;

/**
 * A_exponent_float association proxy interface.
 */
public interface AExponentFloat extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param exponent Value of the first association end.
     * @param efloat Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(database.Int exponent, database.Float efloat);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param efloat Required value of the second association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.Int getExponent(database.Float efloat);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param exponent Required value of the first association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.Float getEfloat(database.Int exponent);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param exponent Value of the first association end.
     * @param efloat Value of the second association end.
     */
    public boolean add(database.Int exponent, database.Float efloat);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param exponent Value of the first association end.
     * @param efloat Value of the second association end.
     */
    public boolean remove(database.Int exponent, database.Float efloat);
}
