package database;

/**
 * A_mantissa_float association proxy interface.
 */
public interface AMantissaFloat extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param mantissa Value of the first association end.
     * @param mfloat Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(database.Int mantissa, database.Float mfloat);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param mfloat Required value of the second association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.Int getMantissa(database.Float mfloat);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param mantissa Required value of the first association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.Float getMfloat(database.Int mantissa);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param mantissa Value of the first association end.
     * @param mfloat Value of the second association end.
     */
    public boolean add(database.Int mantissa, database.Float mfloat);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param mantissa Value of the first association end.
     * @param mfloat Value of the second association end.
     */
    public boolean remove(database.Int mantissa, database.Float mfloat);
}
