package database;

/**
 * A_table_dataBase association proxy interface.
 */
public interface ATableDataBase extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param table Value of the first association end.
     * @param dataBase Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(database.Table table, database.DataBase dataBase);
    /**
     * Queries the instance objects that are related to a particular instance 
     * object by a link in the current associations link set.
     * @param dataBase Required value of the second association end.
     * @return Collection of related objects.
     */
    public java.util.Collection getTable(database.DataBase dataBase);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param table Required value of the first association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.DataBase getDataBase(database.Table table);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param table Value of the first association end.
     * @param dataBase Value of the second association end.
     */
    public boolean add(database.Table table, database.DataBase dataBase);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param table Value of the first association end.
     * @param dataBase Value of the second association end.
     */
    public boolean remove(database.Table table, database.DataBase dataBase);
}
