package database;

/**
 * A_type_typedElement association proxy interface.
 */
public interface ATypeTypedElement extends javax.jmi.reflect.RefAssociation {
    /**
     * Queries whether a link currently exists between a given pair of instance 
     * objects in the associations link set.
     * @param type Value of the first association end.
     * @param typedElement Value of the second association end.
     * @return Returns true if the queried link exists.
     */
    public boolean exists(database.DataType type, database.TypedElement typedElement);
    /**
     * Queries the instance object that is related to a particular instance object 
     * by a link in the current associations link set.
     * @param typedElement Required value of the second association end.
     * @return Related object or <code>null</code> if none exists.
     */
    public database.DataType getType(database.TypedElement typedElement);
    /**
     * Queries the instance objects that are related to a particular instance 
     * object by a link in the current associations link set.
     * @param type Required value of the first association end.
     * @return Collection of related objects.
     */
    public java.util.Collection getTypedElement(database.DataType type);
    /**
     * Creates a link between the pair of instance objects in the associations 
     * link set.
     * @param type Value of the first association end.
     * @param typedElement Value of the second association end.
     */
    public boolean add(database.DataType type, database.TypedElement typedElement);
    /**
     * Removes a link between a pair of instance objects in the current associations 
     * link set.
     * @param type Value of the first association end.
     * @param typedElement Value of the second association end.
     */
    public boolean remove(database.DataType type, database.TypedElement typedElement);
}
