package database;

/**
 * DataBase package interface.
 */
public interface DataBasePackage extends javax.jmi.reflect.RefPackage {
    /**
     * Returns DataBase class proxy object.
     * @return DataBase class proxy object.
     */
    public database.DataBaseClass getDataBase();
    /**
     * Returns Table class proxy object.
     * @return Table class proxy object.
     */
    public database.TableClass getTable();
    /**
     * Returns Column class proxy object.
     * @return Column class proxy object.
     */
    public database.ColumnClass getColumn();
    /**
     * Returns Float class proxy object.
     * @return Float class proxy object.
     */
    public database.FloatClass getFloat();
    /**
     * Returns Int class proxy object.
     * @return Int class proxy object.
     */
    public database.IntClass getInt();
    /**
     * Returns Varchar class proxy object.
     * @return Varchar class proxy object.
     */
    public database.VarcharClass getVarchar();
    /**
     * Returns Text class proxy object.
     * @return Text class proxy object.
     */
    public database.TextClass getText();
    /**
     * Returns Multimedia class proxy object.
     * @return Multimedia class proxy object.
     */
    public database.MultimediaClass getMultimedia();
    /**
     * Returns CompositeDataType class proxy object.
     * @return CompositeDataType class proxy object.
     */
    public database.CompositeDataTypeClass getCompositeDataType();
    /**
     * Returns Element class proxy object.
     * @return Element class proxy object.
     */
    public database.ElementClass getElement();
    /**
     * Returns NamedElement class proxy object.
     * @return NamedElement class proxy object.
     */
    public database.NamedElementClass getNamedElement();
    /**
     * Returns TypedElement class proxy object.
     * @return TypedElement class proxy object.
     */
    public database.TypedElementClass getTypedElement();
    /**
     * Returns DataType class proxy object.
     * @return DataType class proxy object.
     */
    public database.DataTypeClass getDataType();
    /**
     * Returns SizedElement class proxy object.
     * @return SizedElement class proxy object.
     */
    public database.SizedElementClass getSizedElement();
    /**
     * Returns ATableDataBase association proxy object.
     * @return ATableDataBase association proxy object.
     */
    public database.ATableDataBase getATableDataBase();
    /**
     * Returns AColumnTable association proxy object.
     * @return AColumnTable association proxy object.
     */
    public database.AColumnTable getAColumnTable();
    /**
     * Returns AMantissaFloat association proxy object.
     * @return AMantissaFloat association proxy object.
     */
    public database.AMantissaFloat getAMantissaFloat();
    /**
     * Returns AExponentFloat association proxy object.
     * @return AExponentFloat association proxy object.
     */
    public database.AExponentFloat getAExponentFloat();
    /**
     * Returns Structuration association proxy object.
     * @return Structuration association proxy object.
     */
    public database.Structuration getStructuration();
    /**
     * Returns ATypeTypedElement association proxy object.
     * @return ATypeTypedElement association proxy object.
     */
    public database.ATypeTypedElement getATypeTypedElement();
}
