package database;

/**
 * Float object instance interface.
 */
public interface Float extends database.DataType {
    /**
     * Returns the value of reference mantissa.
     * @return Value of reference mantissa.
     */
    public database.Int getMantissa();
    /**
     * Sets the value of reference mantissa. See {@link #getMantissa} for description 
     * on the reference.
     * @param newValue New value to be set.
     */
    public void setMantissa(database.Int newValue);
    /**
     * Returns the value of reference exponent.
     * @return Value of reference exponent.
     */
    public database.Int getExponent();
    /**
     * Sets the value of reference exponent. See {@link #getExponent} for description 
     * on the reference.
     * @param newValue New value to be set.
     */
    public void setExponent(database.Int newValue);
}
