
import org.irisa.triskell.MT.DataTypes.Java.defaultImpl.*;
import org.irisa.triskell.MT.repository.API.Java.CommonException;
import org.irisa.triskell.MT.repository.API.Java.IllegalAccessException;
import org.irisa.triskell.MT.repository.API.Java.MetaAssociation;
import org.irisa.triskell.MT.repository.API.Java.MetaAssociationEnd;
import org.irisa.triskell.MT.repository.API.Java.MetaAttribute;
import org.irisa.triskell.MT.repository.API.Java.MetaClass;
import org.irisa.triskell.MT.repository.API.Java.ModelElement;
import org.irisa.triskell.MT.repository.API.Java.ModelRole;
import org.irisa.triskell.MT.repository.API.Java.UnknownElementException;
import org.irisa.triskell.MT.repository.MDRDriver.Java.*;

public class Championship {

    public static void main(String[] args) {
        Championship factory = new Championship ();
        try {
            factory.BuildInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void BuildInstance() throws Exception {

        api = new MDRAPI(null, new XmiMetamodel("Z:/doc/UML/MDRDemo/eclipse/Generation/Objecteering/Models/DataBase_MOF.xml","DataBase"), this.getClass().getName(), new XmiModel("Z:/doc/UML/MDRDemo/eclipse/Generation/Objecteering/Models/Championship.xml", XmiModel.Write));
        api.startup(null); 

        MetaClass mc_DataBase = api.getMetaClass(new String [] {"DataBase","DataBase"});
        MetaClass mc_Table = api.getMetaClass(new String [] {"DataBase","Table"});
        MetaClass mc_Column = api.getMetaClass(new String [] {"DataBase","Column"});
        MetaClass mc_Float = api.getMetaClass(new String [] {"DataBase","Float"});
        MetaClass mc_Int = api.getMetaClass(new String [] {"DataBase","Int"});
        MetaClass mc_Varchar = api.getMetaClass(new String [] {"DataBase","Varchar"});
        MetaClass mc_Text = api.getMetaClass(new String [] {"DataBase","Text"});
        MetaClass mc_Multimedia = api.getMetaClass(new String [] {"DataBase","Multimedia"});
        MetaClass mc_CompositeDataType = api.getMetaClass(new String [] {"DataBase","CompositeDataType"});
        MetaClass mc_Element = api.getMetaClass(new String [] {"DataBase","Element"});
        MetaClass mc_NamedElement = api.getMetaClass(new String [] {"DataBase","NamedElement"});
        MetaClass mc_TypedElement = api.getMetaClass(new String [] {"DataBase","TypedElement"});
        MetaClass mc_DataType = api.getMetaClass(new String [] {"DataBase","DataType"});
        MetaClass mc_SizedElement = api.getMetaClass(new String [] {"DataBase","SizedElement"});

        MetaAssociationEnd mae_table_Table_DataBase = api.getMetaAssociationEnd("table",mc_Table,mc_DataBase);
        MetaAssociationEnd mae_dataBase_DataBase_Table = api.getMetaAssociationEnd("dataBase",mc_DataBase,mc_Table);
        MetaAssociationEnd mae_column_Column_Table = api.getMetaAssociationEnd("column",mc_Column,mc_Table);
        MetaAssociationEnd mae_table_Table_Column = api.getMetaAssociationEnd("table",mc_Table,mc_Column);
        MetaAttribute ma_isPrimaryKey = api.getMetaAttribute("isPrimaryKey",null);
        MetaAssociationEnd mae_mantissa_Int_Float = api.getMetaAssociationEnd("mantissa",mc_Int,mc_Float);
        MetaAssociationEnd mae_exponent_Int_Float = api.getMetaAssociationEnd("exponent",mc_Int,mc_Float);
        MetaAssociationEnd mae_mfloat_Float_Int = api.getMetaAssociationEnd("mfloat",mc_Float,mc_Int);
        MetaAssociationEnd mae_efloat_Float_Int = api.getMetaAssociationEnd("efloat",mc_Float,mc_Int);
        MetaAttribute ma_unsigned = api.getMetaAttribute("unsigned",null);
        MetaAssociationEnd mae_part_DataType_CompositeDataType = api.getMetaAssociationEnd("part",mc_DataType,mc_CompositeDataType);
        MetaAttribute ma_name = api.getMetaAttribute("name",null);
        MetaAssociationEnd mae_type_DataType_TypedElement = api.getMetaAssociationEnd("type",mc_DataType,mc_TypedElement);
        MetaAssociationEnd mae_typedElement_TypedElement_DataType = api.getMetaAssociationEnd("typedElement",mc_TypedElement,mc_DataType);
        MetaAssociationEnd mae_structure_CompositeDataType_DataType = api.getMetaAssociationEnd("structure",mc_CompositeDataType,mc_DataType);
        MetaAttribute ma_size = api.getMetaAttribute("size",null);

        ModelElement me_Championship = mc_DataBase.instanciate (null,null);
        ModelElement me_Teams = mc_Table.instanciate (null,null);
        ModelElement me_name = mc_Column.instanciate (null,null);
        ModelElement me_Match = mc_Table.instanciate (null,null);
        ModelElement me_VARCHAR_256 = mc_Varchar.instanciate (null,null);
        ModelElement me_Team1 = mc_Column.instanciate (null,null);
        ModelElement me_Team2 = mc_Column.instanciate (null,null);
        ModelElement me_DateDataType = mc_CompositeDataType.instanciate (null,null);
        ModelElement me_Day = mc_Int.instanciate (null,null);
        ModelElement me_Month = mc_Int.instanciate (null,null);
        ModelElement me_Year = mc_Int.instanciate (null,null);
        ModelElement me_Date = mc_Column.instanciate (null,null);
        ModelElement me_Place = mc_Column.instanciate (null,null);
        ModelElement me_INT_5 = mc_Int.instanciate (null,null);
        ModelElement me_Score1 = mc_Column.instanciate (null,null);
        ModelElement me_Score2 = mc_Column.instanciate (null,null);

        LinkTwoModelElements (me_Championship,mae_dataBase_DataBase_Table,me_Teams,mae_table_Table_DataBase);
        LinkTwoModelElements (me_Championship,mae_dataBase_DataBase_Table,me_Match,mae_table_Table_DataBase);
        LinkTwoModelElements (me_Teams,mae_table_Table_DataBase,me_Championship,mae_dataBase_DataBase_Table);
        LinkTwoModelElements (me_Teams,mae_table_Table_Column,me_name,mae_column_Column_Table);
        LinkTwoModelElements (me_name,mae_column_Column_Table,me_Teams,mae_table_Table_Column);
        LinkTwoModelElements (me_name,mae_type_DataType_TypedElement,me_Team1,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_name,mae_typedElement_TypedElement_DataType,me_VARCHAR_256,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_name,mae_type_DataType_TypedElement,me_Team2,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_Match,mae_table_Table_DataBase,me_Championship,mae_dataBase_DataBase_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Team1,mae_column_Column_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Team2,mae_column_Column_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Date,mae_column_Column_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Place,mae_column_Column_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Score1,mae_column_Column_Table);
        LinkTwoModelElements (me_Match,mae_table_Table_Column,me_Score2,mae_column_Column_Table);
        LinkTwoModelElements (me_VARCHAR_256,mae_type_DataType_TypedElement,me_name,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_VARCHAR_256,mae_type_DataType_TypedElement,me_Place,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_Team1,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Team1,mae_typedElement_TypedElement_DataType,me_name,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_Team2,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Team2,mae_typedElement_TypedElement_DataType,me_name,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_DateDataType,mae_structure_CompositeDataType_DataType,me_Day,mae_part_DataType_CompositeDataType);
        LinkTwoModelElements (me_DateDataType,mae_structure_CompositeDataType_DataType,me_Month,mae_part_DataType_CompositeDataType);
        LinkTwoModelElements (me_DateDataType,mae_structure_CompositeDataType_DataType,me_Year,mae_part_DataType_CompositeDataType);
        LinkTwoModelElements (me_DateDataType,mae_type_DataType_TypedElement,me_Date,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_Day,mae_part_DataType_CompositeDataType,me_DateDataType,mae_structure_CompositeDataType_DataType);
        LinkTwoModelElements (me_Month,mae_part_DataType_CompositeDataType,me_DateDataType,mae_structure_CompositeDataType_DataType);
        LinkTwoModelElements (me_Year,mae_part_DataType_CompositeDataType,me_DateDataType,mae_structure_CompositeDataType_DataType);
        LinkTwoModelElements (me_Date,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Date,mae_typedElement_TypedElement_DataType,me_DateDataType,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_Place,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Place,mae_typedElement_TypedElement_DataType,me_VARCHAR_256,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_INT_5,mae_type_DataType_TypedElement,me_Score1,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_INT_5,mae_type_DataType_TypedElement,me_Score2,mae_typedElement_TypedElement_DataType);
        LinkTwoModelElements (me_Score1,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Score1,mae_typedElement_TypedElement_DataType,me_INT_5,mae_type_DataType_TypedElement);
        LinkTwoModelElements (me_Score2,mae_column_Column_Table,me_Match,mae_table_Table_Column);
        LinkTwoModelElements (me_Score2,mae_typedElement_TypedElement_DataType,me_INT_5,mae_type_DataType_TypedElement);

        me_Championship.setAttributeValue (me_Championship,ma_name,new StringValueImpl(false,null,"Championship"));
        me_Teams.setAttributeValue (me_Teams,ma_name,new StringValueImpl(false,null,"Teams"));
        me_name.setAttributeValue (me_name,ma_name,new StringValueImpl(false,null,"name"));
        me_name.setAttributeValue (me_name,ma_isPrimaryKey,new BooleanValueImpl(false,null,true));
        me_Match.setAttributeValue (me_Match,ma_name,new StringValueImpl(false,null,"Match"));
        me_VARCHAR_256.setAttributeValue (me_VARCHAR_256,ma_name,new StringValueImpl(false,null,"VARCHAR(256)"));
        me_VARCHAR_256.setAttributeValue (me_VARCHAR_256,ma_size,new IntegerValueImpl(false,null,256));
        me_Team1.setAttributeValue (me_Team1,ma_name,new StringValueImpl(false,null,"Team1"));
        me_Team1.setAttributeValue (me_Team1,ma_isPrimaryKey,new BooleanValueImpl(false,null,true));
        me_Team2.setAttributeValue (me_Team2,ma_name,new StringValueImpl(false,null,"Team2"));
        me_Team2.setAttributeValue (me_Team2,ma_isPrimaryKey,new BooleanValueImpl(false,null,true));
        me_DateDataType.setAttributeValue (me_DateDataType,ma_name,new StringValueImpl(false,null,"DateDataType"));
        me_Day.setAttributeValue (me_Day,ma_name,new StringValueImpl(false,null,"Day"));
        me_Day.setAttributeValue (me_Day,ma_size,new IntegerValueImpl(false,null,5));
        me_Day.setAttributeValue (me_Day,ma_unsigned,new BooleanValueImpl(false,null,true));
        me_Month.setAttributeValue (me_Month,ma_name,new StringValueImpl(false,null,"Month"));
        me_Month.setAttributeValue (me_Month,ma_size,new IntegerValueImpl(false,null,4));
        me_Month.setAttributeValue (me_Month,ma_unsigned,new BooleanValueImpl(false,null,true));
        me_Year.setAttributeValue (me_Year,ma_name,new StringValueImpl(false,null,"Year"));
        me_Year.setAttributeValue (me_Year,ma_size,new IntegerValueImpl(false,null,7));
        me_Year.setAttributeValue (me_Year,ma_unsigned,new BooleanValueImpl(false,null,true));
        me_Date.setAttributeValue (me_Date,ma_name,new StringValueImpl(false,null,"Date"));
        me_Date.setAttributeValue (me_Date,ma_isPrimaryKey,new BooleanValueImpl(false,null,true));
        me_Place.setAttributeValue (me_Place,ma_name,new StringValueImpl(false,null,"Place"));
        me_Place.setAttributeValue (me_Place,ma_isPrimaryKey,new BooleanValueImpl(false,null,false));
        me_INT_5.setAttributeValue (me_INT_5,ma_name,new StringValueImpl(false,null,"INT(5)"));
        me_INT_5.setAttributeValue (me_INT_5,ma_size,new IntegerValueImpl(false,null,5));
        me_INT_5.setAttributeValue (me_INT_5,ma_unsigned,new BooleanValueImpl(false,null,true));
        me_Score1.setAttributeValue (me_Score1,ma_name,new StringValueImpl(false,null,"Score1"));
        me_Score1.setAttributeValue (me_Score1,ma_isPrimaryKey,new BooleanValueImpl(false,null,false));
        me_Score2.setAttributeValue (me_Score2,ma_name,new StringValueImpl(false,null,"Score2"));
        me_Score2.setAttributeValue (me_Score2,ma_isPrimaryKey,new BooleanValueImpl(false,null,false));

        api.shutdown(null);
    }

    private void LinkTwoModelElements (ModelElement me_source, MetaAssociationEnd ae_source, ModelElement me_target, MetaAssociationEnd ae_target)
    {
        try {
            MetaAssociation assoc = api.getMetaAssociationWithAssociationEnds(new MetaAssociationEnd[] { ae_source, ae_target });
            assoc.associateModelElements (null,	new ModelRole [] { api.getRole(me_target, ae_target), api.getRole(me_source, ae_source)	} );
        } catch (UnknownElementException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (CommonException e) {
            e.printStackTrace();
        }
    }

    private MDRAPI api = null;

    static {
        org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger("ObjecteeringMetamodellingModule");			
        try {
            String filePath = new java.io.File("../resources/log4j/log4j_configuration").getCanonicalPath();			
            org.apache.log4j.LogManager.resetConfiguration();
            org.apache.log4j.xml.DOMConfigurator.configure(filePath);
        } catch (java.io.IOException e) {
            e.printStackTrace();
        }
    }

}