/*
 * Created on Nov 4, 2003
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package ch.epfl.lgl.mdrdemo;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Iterator;

import database.Column;
import database.CompositeDataType;
import database.DataBase;
import database.DataBasePackage;
import database.DataType;
import database.SizedElement;
import database.Table;

/**
 * A demo class to view how to use JMI specific interfaces, and then store the result model into an XMI file.
 */
public class MDRDemo_UseSpecificJMIAndStoreChampionshipModel extends MDRDemo_Initialization {
		
	public static void main (String [] args) {
		try {
			DataBasePackage service = (DataBasePackage)getExtent("Championship_Extent");
			
			//Creates the DataType VARCHAR 256 - checking the type instanciation by accessing the meta object
			DataType varchar256dt = service.getVarchar().createVarchar("VARCHAR(256)", 256);
			System.out.println("Datatype created with name " + varchar256dt.getName() + " and size " +((SizedElement)varchar256dt).getSize() + " (class is " + varchar256dt.refClass().refMetaObject().refGetValue("name").toString() + ")");
			//Creates the DataType INT 5 - checking the type instanciation by accessing the meta object
			DataType int5dt = service.getInt().createInt("INT(5)", 5, true);
			System.out.println("Datatype created with name " + int5dt.getName() + " and size " +((SizedElement)int5dt).getSize() + " (class is " + int5dt.refClass().refMetaObject().refGetValue("name").toString() + ")");
			//Creates the DataType DAY - checking the type instanciation by accessing the meta object
			DataType daydt = service.getInt().createInt("DAY", 5, true);
			System.out.println("Datatype created with name " + daydt.getName() + " and size " +((SizedElement)daydt).getSize() + " (class is " + daydt.refClass().refMetaObject().refGetValue("name").toString() + ")");
			//Creates the DataType MONTH - checking the type instanciation by accessing the meta object
			DataType monthdt = service.getInt().createInt("MONTH", 4, true);
			System.out.println("Datatype created with name " + monthdt.getName() + " and size " +((SizedElement)monthdt).getSize() + " (class is " + monthdt.refClass().refMetaObject().refGetValue("name").toString() + ")");
			//Creates the DataType YEAR - checking the type instanciation by accessing the meta object
			DataType yeardt = service.getInt().createInt("YEAR", 5, true);
			System.out.println("Datatype created with name " + yeardt.getName() + " and size " +((SizedElement)yeardt).getSize() + " (class is " + yeardt.refClass().refMetaObject().refGetValue("name").toString() + ")");
			//Creates composite DataType DATE
			CompositeDataType datedt = service.getCompositeDataType().createCompositeDataType("DATE");
			//Adding DAY, MONTH and YEAR to DATE composite
			service.getStructuration().add(daydt, datedt);
			service.getStructuration().add(monthdt, datedt);
			service.getStructuration().add(yeardt, datedt);
			System.out.print("Composite data type created with name " + datedt.getName() + " and parts ");
			Iterator partIt = datedt.getPart().iterator();
			boolean first = true;
			while(partIt.hasNext()) {
				if (first)
					first = false;
				else
					System.out.print(", ");
				System.out.print(((DataType)partIt.next()).getName());
			}
			System.out.println();
			
			//Creates the database
			DataBase championship = service.getDataBase().createDataBase("Championship");
			System.out.println("Database created with name " + championship.getName());
			
			//Creates the Teams table
			Table teams = service.getTable().createTable("Teams");
			System.out.println("Table created with name " + teams.getName());
			//Sets championship as its container
			teams.setDataBase(championship);
			System.out.println("Table " + teams.getName() + " added to database " + teams.getDataBase().getName());
			//Now, creates the name column and references it in Teams table
			Column teamsName = service.getColumn().createColumn("name", true);
			teamsName.setType(varchar256dt);
			// another wa to create a link
			teams.getColumn().add(teamsName);
			System.out.println("Column ceated with name " + teamsName.getName() + " of data type " + teamsName.getType().getName() + " in table " + teamsName.getTable().getName() + (teamsName.isPrimaryKey() ? " as primary key":"") + (teamsName.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)teamsName.getType()).getName() + " in table " + ((Column)teamsName.getType()).getTable().getName(): ""));
			
			//Creates the Championship table
			//Creates the Teams table
			Table champ = service.getTable().createTable("Championship");
			System.out.println("Table created with name " + champ.getName());
			//Sets championship as its container
			championship.getTable().add(champ);
			System.out.println("Table " + champ.getName() + " added to database " + champ.getDataBase().getName());
			//Creates the Team1, Team2, Date, Place Score1 and Score2 Columns
			Column chamTeam1 = service.getColumn().createColumn("Team1", true);
			chamTeam1.setType(teamsName);
			chamTeam1.setTable(champ);
			System.out.println("Column ceated with name " + chamTeam1.getName() + " of data type " + chamTeam1.getType().getName() + " in table " + chamTeam1.getTable().getName() + ((chamTeam1.isPrimaryKey()) ? " as primary key":"") + (chamTeam1.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamTeam1.getType()).getName() + " in table " + ((Column)chamTeam1.getType()).getTable().getName(): ""));
			Column chamTeam2 = service.getColumn().createColumn("Team2", true);
			chamTeam2.setType(teamsName);
			chamTeam2.setTable(champ);
			System.out.println("Column ceated with name " + chamTeam2.getName() + " of data type " + chamTeam2.getType().getName() + " in table " + chamTeam2.getTable().getName() + (chamTeam2.isPrimaryKey() ? " as primary key":"") + (chamTeam2.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamTeam2.getType()).getName() + " in table " + ((Column)chamTeam2.getType()).getTable().getName(): ""));
			Column chamDate = service.getColumn().createColumn("Date", true);
			chamDate.setType(datedt);
			chamDate.setTable(champ);
			System.out.println("Column ceated with name " + chamDate.getName() + " of data type " + chamDate.getType().getName() + " in table " + chamDate.getTable().getName() + (chamDate.isPrimaryKey() ? " as primary key":"") + (chamDate.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamDate.getType()).getName() + " in table " + ((Column)chamDate.getType()).getTable().getName(): ""));
			Column chamPlace = service.getColumn().createColumn("Place", true);
			chamPlace.setType(varchar256dt);
			chamPlace.setTable(champ);
			System.out.println("Column ceated with name " + chamPlace.getName() + " of data type " + chamPlace.getType().getName() + " in table " + chamPlace.getTable().getName() + (chamPlace.isPrimaryKey() ? " as primary key":"") + (chamPlace.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamPlace.getType()).getName() + " in table " + ((Column)chamPlace.getType()).getTable().getName(): ""));
			Column chamScore1 = service.getColumn().createColumn("Score1", false);
			chamScore1.setType(int5dt);
			chamScore1.setTable(champ);
			System.out.println("Column ceated with name " + chamScore1.getName() + " of data type " + chamScore1.getType().getName() + " in table " + chamScore1.getTable().getName() + ((chamScore1.isPrimaryKey()) ? " as primary key":"") + (chamScore1.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamScore1.getType()).getName() + " in table " + ((Column)chamScore1.getType()).getTable().getName(): ""));
			Column chamScore2 = service.getColumn().createColumn("Score2", false);
			chamScore2.setType(int5dt);
			chamScore2.setTable(champ);
			System.out.println("Column ceated with name " + chamScore2.getName() + " of data type " + chamScore2.getType().getName() + " in table " + chamScore2.getTable().getName() + ((chamScore2.isPrimaryKey()) ? " as primary key":"") + (chamScore2.getType().refIsInstanceOf(service.getColumn().refMetaObject(), true) ? " as foreign key for column " + ((Column)chamScore2.getType()).getName() + " in table " + ((Column)chamScore2.getType()).getTable().getName(): ""));
			
			//and store the result into an XMI file
			writer.write(new BufferedOutputStream(new FileOutputStream(new File(rootPackage + "/generation/MDR/Models/Championship_gen.xml"))), service, "1.2");
			System.out.println("Saved to " + rootPackage + "/generation/MDR/Models/Championship_gen.xml");
			
		} catch (Exception x) {
			x.printStackTrace();
		}
	}
}
